package sun.io;

public class CharToByte8859_1 extends CharToByteConverter {
   private char highHalfZoneCode;

   public String getCharacterEncoding() {
      return "8859_1";
   }

   public int flush(byte[] var1, int var2, int var3) throws MalformedInputException {
      if (this.highHalfZoneCode != 0) {
         this.highHalfZoneCode = 0;
         throw new MalformedInputException("String ends with <High Half Zone code> of UTF16");
      } else {
         super.byteOff = super.charOff = 0;
         return 0;
      }
   }

   public int convert(char[] var1, int var2, int var3, byte[] var4, int var5, int var6) throws MalformedInputException, UnknownCharacterException, ConversionBufferFullException {
      byte[] var9 = new byte[1];
      super.charOff = var2;
      super.byteOff = var5;
      if (this.highHalfZoneCode != 0) {
         char var14 = this.highHalfZoneCode;
         this.highHalfZoneCode = 0;
         if (var1[var2] >= '\udc00' && var1[var2] <= '\udfff') {
            super.badInputLength = 1;
            throw new UnknownCharacterException();
         } else {
            super.badInputLength = 0;
            throw new MalformedInputException("Previous converted string ends with <High Half Zone Code> of UTF16 , but this string is not begin with <Low Half Zone>");
         }
      } else {
         while(super.charOff < var3) {
            byte[] var8 = var9;
            char var7 = var1[super.charOff];
            int var11 = 1;
            byte var10 = 1;
            if (var7 >= '\ud800' && var7 <= '\udbff') {
               if (super.charOff + 1 == var3) {
                  this.highHalfZoneCode = var7;
                  break;
               }

               var7 = var1[super.charOff + 1];
               if (var7 < '\udc00' || var7 > '\udfff') {
                  super.badInputLength = 1;
                  throw new MalformedInputException();
               }

               if (!super.subMode) {
                  super.badInputLength = 2;
                  throw new UnknownCharacterException();
               }

               var8 = super.subBytes;
               var11 = super.subBytes.length;
               var10 = 2;
            } else {
               if (var7 >= '\udc00' && var7 <= '\udfff') {
                  super.badInputLength = 1;
                  throw new MalformedInputException();
               }

               if (var7 <= 255) {
                  var9[0] = (byte)var7;
               } else {
                  if (!super.subMode) {
                     super.badInputLength = 1;
                     throw new UnknownCharacterException();
                  }

                  var8 = super.subBytes;
                  var11 = super.subBytes.length;
               }
            }

            if (super.byteOff + var11 > var6) {
               throw new ConversionBufferFullException();
            }

            for(int var12 = 0; var12 < var11; ++var12) {
               var4[super.byteOff++] = var8[var12];
            }

            super.charOff += var10;
         }

         return super.byteOff - var5;
      }
   }

   public boolean canConvert(char var1) {
      return var1 <= 255;
   }

   public void reset() {
      super.byteOff = super.charOff = 0;
      this.highHalfZoneCode = 0;
   }

   public int getMaxBytesPerChar() {
      return 1;
   }
}
