package sun.io;

public abstract class CharToByteSingleByte extends CharToByteConverter {
   protected short[] index1;
   protected byte[] index2;
   protected int mask1;
   protected int mask2;
   protected int shift;
   protected int badInputLength;
   private char highHalfZoneCode;

   public int flush(byte[] var1, int var2, int var3) throws MalformedInputException {
      if (this.highHalfZoneCode != 0) {
         this.highHalfZoneCode = 0;
         this.badInputLength = 0;
         throw new MalformedInputException();
      } else {
         super.byteOff = super.charOff = 0;
         return 0;
      }
   }

   public int convert(char[] var1, int var2, int var3, byte[] var4, int var5, int var6) throws MalformedInputException, UnknownCharacterException, ConversionBufferFullException {
      byte[] var11 = new byte[1];
      super.charOff = var2;
      super.byteOff = var5;
      if (this.highHalfZoneCode != 0) {
         char var14 = this.highHalfZoneCode;
         this.highHalfZoneCode = 0;
         if (var1[var2] >= '\udc00' && var1[var2] <= '\udfff') {
            this.badInputLength = 1;
            throw new UnknownCharacterException();
         } else {
            this.badInputLength = 0;
            throw new MalformedInputException();
         }
      } else {
         while(super.charOff < var3) {
            byte[] var8 = var11;
            char var7 = var1[super.charOff];
            int var10 = 1;
            byte var9 = 1;
            if (var7 >= '\ud800' && var7 <= '\udbff') {
               if (super.charOff + 1 >= var3) {
                  this.highHalfZoneCode = var7;
                  break;
               }

               var7 = var1[super.charOff + 1];
               if (var7 < '\udc00' || var7 > '\udfff') {
                  this.badInputLength = 1;
                  throw new MalformedInputException();
               }

               if (!super.subMode) {
                  this.badInputLength = 2;
                  throw new UnknownCharacterException();
               }

               var8 = super.subBytes;
               var10 = super.subBytes.length;
               var9 = 2;
            } else {
               if (var7 >= '\udc00' && var7 <= '\udfff') {
                  this.badInputLength = 1;
                  throw new MalformedInputException();
               }

               var11[0] = this.index2[this.index1[(var7 & this.mask1) >> this.shift] + (var7 & this.mask2)];
               if (var11[0] == 0 && var1[super.charOff] != 0) {
                  if (!super.subMode) {
                     this.badInputLength = 1;
                     throw new UnknownCharacterException();
                  }

                  var8 = super.subBytes;
                  var10 = super.subBytes.length;
               }
            }

            if (super.byteOff + var10 > var6) {
               throw new ConversionBufferFullException();
            }

            for(int var12 = 0; var12 < var10; ++var12) {
               var4[super.byteOff++] = var8[var12];
            }

            super.charOff += var9;
         }

         return super.byteOff - var5;
      }
   }

   public int getMaxBytesPerChar() {
      return 1;
   }

   public void reset() {
      super.byteOff = super.charOff = 0;
      this.highHalfZoneCode = 0;
   }

   public boolean canConvert(char var1) {
      if (this.index2[this.index1[(var1 & this.mask1) >> this.shift] + (var1 & this.mask2)] != 0) {
         return true;
      } else {
         return var1 == 0;
      }
   }
}
